<?php
/**
 *  PHPOF2/Driver/DBResult/mysqli.php - PHPOF2 MySQLi driver for DBResults
 *
 * (c)2001-2010 Tim Jackson (tim@timj.co.uk)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of version 3 of the GNU Lesser General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @package PHPOF2
 * @subpackage Driver_mysqli
 * 
 */
require_once 'MDB2/Driver/mysqli.php';
require_once 'PHPOF2/DBResult/Interface.php';

class PHPOF2_Driver_DBResult_mysqli extends MDB2_Result_mysqli implements PHPOF2_DBResult_Interface
{

	
}

class PHPOF2_Driver_DBResult_Buffered_mysqli extends MDB2_BufferedResult_mysqli implements PHPOF2_DBResult_Interface
{

	// ---------------------------------------------------------
	// not MySQLi-specific
	
	/**
	 * Get array of results
	 * 
	 * If "key" and "value" are defined, then the column referenced in "key" is
	 * used as the array's key and the column referenced in "value" is used as
	 * the value.
	 * 
	 * If "key" only is defined, then the result is a non-assoc array simply
	 * containing the results from the DB column called "[key]"
	 *
	 * @param string $key
	 * @param string $value
	 * @return array
	 */
	public function getArray ($key, $value=PHPOF2_DBResult_Interface::ARRAY_LINEAR) {
		$array = array();
		while ($result = $this->fetchRow(MDB2_FETCHMODE_ASSOC)) {
			if ($value == PHPOF2_DBResult_Interface::ARRAY_LINEAR) {
				$array[] = $result[$key];
			} else {
				$array[$result[$key]] = $result[$value];
			}
		}
		return $array;
	}
	
	// TODO DN stuff
	
	public function fetchIntoObject (&$object_to_fill) {
		if (!$object_to_fill instanceof PHPOF2_DBRow) {
			throw new Exception('PHPOF2_DBResult::fetchIntoObject() was not passed a DBRow object');
		}
		return $object_to_fill->fillFromResult($this);
	}
}
