<?php

/**
 *  PHPOF2/Driver/DBRow/mysqli.php - MySQL support module for PHPOF2_DBRow
 *
 * (c)2001-2008 Tim Jackson (tim@timj.co.uk)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of version 3 of the GNU Lesser General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * @package PHPOF2
 * @subpackage Driver_mysqli
 * 
 */

class PHPOF2_Driver_DBRow_mysqli {

	public static function storeLOBDataFromFile (&$row, $dest_column_name, $filename)
	{
		if ($fd = fopen($filename,'r')) {
			$filesize = filesize($filename);
			$SQL = 'UPDATE '.$row->table->name.
				" SET $dest_column_name='".$row->db->escape( fread($fd,$filesize) )."'";
				$SQL .= 'WHERE '.$row->getPrikeyWhereClause();
			fclose($fd);
			$res = $row->db->query($SQL);
			if (PEAR::isError($res)) {
	    		throw new Exception($res->getMessage());
			}
		} else {
			throw new Exception("Could not open temp file '$filename' for reading");
		}
	}
	
	public static function storeLOBDataFromBuffer (&$row, $dest_column_name, &$data)
	{
		if ($data === null) {
			$value = 'NULL';
		} else {
			$value = $row->db->quote($data);
		}
		$SQL = 'UPDATE ' . $row->table->name . " SET $dest_column_name=" . $value . ' WHERE ' . $row->getPrikeyWhereClause();
		
		$res = $row->db->query($SQL);
		if (PEAR::isError($res)) {
    		throw new Exception($res->getMessage());
		}
	}
	
	public static function retrieveLOBData (&$row, $column_name, $resultarray)
	{
		return $resultarray[$column_name];
	}
	
	public static function removeLOBData (&$row, $column_name)
	{
		$res = $row->db->query(
			'UPDATE '.$row->table->name.
			" SET $column_name=NULL WHERE ".$row->getPrikeyWhereClause());
		if (PEAR::isError($res)) {
    		throw new Exception($res->getMessage());
		}
	}
	
	public static function resolveLOBFields(&$row)
	{
		$fields_lob = $row->table->getFieldListLOB();
		if (count($fields_lob) > 0) {
			foreach ($fields_lob as $field) {
				$sql = 'SELECT COUNT(*) AS filled'.
						' FROM '.$row->table->name.
						" WHERE $field IS NOT NULL ";
				$sql .= ' AND '.$row->getPrikeyWhereClause();
				
				$res = $row->db->query($sql);
				if (PEAR::isError($res)) {
		    		throw new Exception($res->getMessage());
				}
				$resultarray = $res->fetchRow(MDB2_FETCHMODE_ASSOC);
				if ($resultarray['filled']) {
					$row->$field = PHPOF2_DB::LOB_PLACEHOLDER;
				} else {
					$row->$field = null;
				}
			}
		}
		return true;
	}
	
}

?>
